﻿#!/usr/bin/env python
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to:
#     The Free Software Foundation, Inc.,
#     51 Franklin Street, Fifth Floor
#     Boston, MA  02110-1301, USA.
#
#The licensing nature of this project is subject to change solely by the author
#
# Author: Devtar Singh <devtar@gmail.com>
# Text Encoding: UTF-8

import bt
import network
import os

import shelve
import cPickle

import sys
import ctypes
import gobject
import sys, string

from xml.sax import handler, make_parser
import xmlparse

from time import sleep
try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
except:
	print "Essential GTK Glade libraries not found!"
	sys.exit(1)
	#program main
#save file output format
FILE_EXT = "xml"
FILE2_EXT = "ubt"
#scanning mode
MODE = "null"
#progress bar status
PROGSTATUS = "null"
#portcount 
portcount = 0
#osinfo
osinfo = 0
#osmatch
osmatchcnt = 0
#plugin selected
PLUGSELCT = ""
#scan host
host = ""
#save file
save_file = ""
#open file
open_file = ""
#I/O status
iostatus = False
#bt IO buffer
btname = [ "" ]
btmac = [ "" ]
btmanu = [ "" ]
#temp scan output buffer
line = ""
#temp filename
outf = "temp.xml"
# scan flags
flags = "nmap -O2 -vv -F -T 4"

class main:

	 def __init__(self):
		 print 'start'
		 #Glade Initialization
		 self.gladefile = "scan-intf.glade"  
		 self.wTree = gtk.glade.XML(self.gladefile) 
		 
		 self.window = self.wTree.get_widget("window1")
		 self.about1 = self.wTree.get_widget("dialog1")
		 self.pref = self.wTree.get_widget("dialog2")
		 self.button = self.wTree.get_widget("button1")
		 self.button2 = self.wTree.get_widget("button2")
		 self.textview = self.wTree.get_widget("textview1")
		 self.treeview1 = self.wTree.get_widget("treeview1")
		 self.notebook2 = self.wTree.get_widget("notebook2")
		 #map view
		 self.mapview = self.wTree.get_widget("iconview1")
		 # treeview2 for plugin
		 self.treeview2 = self.wTree.get_widget("treeview2")
		 self.treeview3 = self.wTree.get_widget("treeview3")
		 self.plugintext = self.wTree.get_widget("textview4")
		 self.statusbar = self.wTree.get_widget("statusbar1")
		 #for preference 
		 self.textview6 = self.wTree.get_widget("textview6")
		 self.textview7 = self.wTree.get_widget("textview7")
		 self.progressbar = self.wTree.get_widget("progressbar1")
		 #self.window.show_all()
		 if (self.window):
	  		 self.window.connect("destroy", gtk.main_quit)
		 #Notify Null mode
		 context_id = self.statusbar.get_context_id("mode2")
		 self.statusbar.push(context_id, "Mode Currently Unset")
		 #Create our dictionay and connect it
		 dic = { "on_button1_clicked" : self.button1_clicked
			     , "on_button2_clicked" : self.button2_clicked
				 , "on_closebutton1_clicked" : self.about1_close
				 , "on_window1_destroy" : gtk.main_quit
		 		 , "on_file_new" : self.on_file_new
				 , "on_file_open" : self.on_file_open
				 , "on_file_save" : self.on_file_save
		         , "on_file_save_as": self.on_file_save_as
				 , "on_preferences1_activate": self.on_preferences1_activate
				 , "on_plugin1_activate": self.on_plugin1_activate
				 , "on_cancelbutton1_clicked": self.pref_close
				 , "on_okbutton1_clicked": self.pref_close
				 , "on_treeview1_button_press_event": self.tree1_press
				 , "on_treeview2_button_press_event": self.tree2_press
		         , "on_network_activate": self.on_network_activate
		         , "on_bluetooth_activate": self.on_bluetooth_activate 
		         , "on_about1_activate": self.on_about1_activate }
				#statusbar work
				#"on_statusbar1_text_pushed" : self.statusbar_text_pushed
				#"on_statusbar1_text_popped" : self.status_bar.pop }
		 self.wTree.signal_autoconnect(dic)
		 
		 #initialize plugin needs to be in main
		 model = gtk.TreeStore( gobject.TYPE_STRING, gobject.TYPE_BOOLEAN )
		 self.prefmodel = model
		 self.prefmodel.append( None, ("Neural Network Optimization(Windows)\t\t\t", None) )
		 self.prefmodel.append( None, ("Neural Network Optimization(non Windows)", None) )
		 
		 self.treeview2.set_model(self.prefmodel)
		 
		 #column 1
		 renderer0 = gtk.CellRendererText()
		 column1 = gtk.TreeViewColumn("Plugin", renderer0, text=0 )
		 #column1.set_resizable(True)
		 
		 #column 2
		 renderer1 = gtk.CellRendererToggle()
		 renderer1.set_property('activatable', True)
		 renderer1.connect( 'toggled', self.plugin_toggle, model )		 
		 column2 = gtk.TreeViewColumn("     Activate", renderer1)
		 column2.add_attribute( renderer1, "active", 1)
		 #column2.set_resizable(True)			 
		 
		 self.treeview2.append_column(column1)
		 self.treeview2.append_column(column2)
		 
		 #Treeview for List View		 
		 model = gtk.TreeStore( gobject.TYPE_STRING, gobject.TYPE_STRING )
		 #model = gtk.ListStore( gobject.TYPE_STRING, gobject.TYPE_STRING )
		 self.listmodel = model
		 #model.append( None, ("Neural Network Plugin\t\t\t\t\t\t", None) )
		 self.treeview1.set_model(self.listmodel)
		 
		 column1 = gtk.TreeViewColumn("Host\t\t", renderer0, text=0 )		 
		 column2 = gtk.TreeViewColumn("Details", renderer0, text=1 )
		 self.treeview1.append_column(column1)
		 self.treeview1.append_column(column2)
		 column1.set_resizable(True)
		 
		 global outf
		 global flags
		 self.textview6.get_buffer().set_text(outf)
		 self.textview7.get_buffer().set_text(flags)
		 
		 #Map View initialization
		 model = gtk.ListStore(str, gtk.gdk.Pixbuf)
		 self.mapmodel = model
		 
	 def on_file_new(self, widget):
		 global save_file
		 self.textview.get_buffer().set_text('Welcome to Umit Light')
		 save_file = None
		 #clear list
		 self.listmodel.clear()
		 #clear map
		 self.mapmodel.clear()
    
	 def verify_file(self, save_file):            
			 if os.access(os.path.split(save_file)[0], os.W_OK):                 
				 save_file = open(save_file, "w")                  
				 save_file.seek(0)
				 return True        
			 else:                 
				 print "Don't have write permissions to given path."

	 def on_file_open(self, widget):
		 global save_file
		 global iostatus
		 global open_file
		 global MODE
		 global btname
		 global btmac
		 global btmanu
		 count = 0
		 btmacbuf = ""
		 btnamebuf = ""
		 btmanubuf = ""
		 buffer = ""
		 
		 #clear bt lists
		 if (MODE == "bluetooth"):
			 while ((len(btname)-1) > count):
				 btname.pop()
				 btmac.pop()
				 btmanu.pop()		 
		 count = 0 
		 
		 save_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_OPEN)
		 #If we have a xml_file
		 inFile = open(save_file, "rb")		     
		 buffer, extension = os.path.splitext(save_file)	     
		 print "OPEN FILENAME : " + extension
		 if (save_file and extension == ".xml"):
			 parser = make_parser()		         
			 handler = xmlparse.xmlparsing(self)
			 parser.setContentHandler(handler)		         				 
			 parser.parse(inFile)	 
			 inFile.close()
			 iostatus = True
		 elif (save_file and extension == ".ubt"):
			 self.textview.get_buffer().set_text("")
			 inFile2 = open("btdb.dat", "rb")
			 for line in inFile:
				 count+=1
				 btnamebuf, btmacbuf = line.split("<-name|mac->")
				 btmacbuf, btmanubuf = btmacbuf.split("<-mac|manufac->")
				 #string formatting \ remove newline
				 btname.append(btnamebuf)
				 btmac.append(btmacbuf)
				 btmanu.append(btmanubuf)
				 btname[count] = string.replace(btname[count], "\n", " ")
				 btmac[count] = string.replace(btmac[count], "\n", " ")			     
				 btmanu[count] = string.replace(btmanu[count], "\n", " ")			     
				 buffer = "Device "+str(count)+"\n  Device Name: "+btname[count]+"\n  Device Address: "+btmac[count]+"\n  Device Manufacturer: "+btmanu[count]
				 self.textview.get_buffer().insert_at_cursor(buffer)
			 inFile.close()
		 else:
			 self.textview.get_buffer().set_text("File I/O Error")
		 
		 if (MODE == "network"):
			 self.listmodel.clear()
			 xmlparse.xmlprint(self)
		 elif (MODE == "bluetooth"):
		     self.bt_list()
		 #Bluetooth Manifacturer identification [OUI based]	 

	 #xml_save_to_file func removed. xmlparse.py used 
	 def on_file_save(self, widget):
		 global save_file
		 global open_file
		 global MODE
		 global outf
		 global iostatus
		 global btname
		 global btmac
		 global btmanu
		 count = 0
		 """This function saves the current post as an XML file"""
		# Let the user browse for the save location and name		 	     
		 if (save_file == None):
			 save_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_SAVE)
		 #If we have a xml_file
		 print "Before Filename: " + save_file
		 root, self.project_file = os.path.split(save_file)
		 print "After Filename: " + self.project_file
		 if (save_file and self.verify_file(save_file)):
			 if (MODE=="network"):			     
				 save_file, extension = os.path.splitext(save_file)
				 print "Ext : " + extension
				 save_file = save_file + "." + FILE_EXT
				 print "Before Filename: " + save_file
				 if sys.platform !="win32":				     
					 if (iostatus == True):					     
						 command = "cp " + open_file  + " " + self.project_file
						 # File has to be reopened for it to be saved properly so realtime scanning results would be saved correctly
						 iostatus = False
					 elif (iostatus == False):
						 command = "cp " + outf  + " " + self.project_file
					 os.popen(command)
					 print command
					 #command = "rm " + outf
					 #os.popen(command)
				 else:	 
					 if (iostatus == True):					     
						 command = "copy "+ open_file  + " " + self.project_file
						 iostatus = False
					 elif ( iostatus == False):
					     command = "copy "+ outf  + " " + self.project_file
					 os.popen(command)
					 print command
					 #command = "del " + outf
					 #os.popen(command)
			 # WORK TO BE DONE HERE !!!
			 elif (MODE=="bluetooth"):
				 save_file, extension = os.path.splitext(save_file)
				 save_file = save_file + "." + FILE2_EXT				 
				 outfile = open (save_file, "w")
				 while (len(btname)-1) > count:
					 count+=1
					 #string formatting \ remove newline
					 btname[count] = string.replace(btname[count], "\n", " ")				     
					 btmac[count] = string.replace(btmac[count], "\n", " ")
					 btmanu[count] = string.replace(btmanu[count], "\n", " ")					 
					 event = btname[count]+"<-name|mac->"+btmac[count]+"<-mac|manufac->"+btmanu[count]+"\n"
					 outfile.writelines(event)
				 outfile.close()				 
				 root, self.project_file = os.path.split(save_file)
				 print root + "\n"
				 print self.project_file
				 	 
	 #func removed. xmlparse.py used 	
	 def on_file_save_as(self, widget):
		 global save_file
		 """Let the user save the current file to a new location."""
		 save_file = ""
		 save_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_SAVE, save_file)
		 if (save_file == None):
			 save_file = os.path.basename(save_file)
		 #If we have a xml_file
		 if (save_file):
			if (self.on_file_save(save_file)):
				 print "AS FILE" + save_file
				 """Allright it all worked! save the current file and
				 set the title."""

	 def file_browse(self, dialog_action, file_name=""):
		"""This function is used to browse for a pyWine file.
		It can be either a save or open dialog depending on
		what dialog_action is.
		The path to the file will be returned if the user
		selects one, however a blank string will be returned
		if they cancel or do not select one.
		dialog_action - The open or save mode for the dialog either
		gtk.FILE_CHOOSER_ACTION_OPEN, gtk.FILE_CHOOSER_ACTION_SAVE
		@param file_name - Default name when doing a save
		@returns - File Name, or None on cancel.
		"""
		global MODE
		
		if (dialog_action==gtk.FILE_CHOOSER_ACTION_OPEN):
			dialog_buttons = (gtk.STOCK_CANCEL
				, gtk.RESPONSE_CANCEL
				, gtk.STOCK_OPEN
				, gtk.RESPONSE_OK)
			dlg_title = "Open Post"
		else:
			dialog_buttons = (gtk.STOCK_CANCEL
				, gtk.RESPONSE_CANCEL
				, gtk.STOCK_SAVE
				, gtk.RESPONSE_OK)
			dlg_title = "Save Post"

		file_dialog = gtk.FileChooserDialog(title=dlg_title
			, action=dialog_action
			, buttons=dialog_buttons)
		"""set the filename if we are saving"""
		if (dialog_action==gtk.FILE_CHOOSER_ACTION_SAVE):
		 file_dialog.set_current_name(file_name)
		 filter = gtk.FileFilter()
		 filter2 = gtk.FileFilter()
		 filter.set_name("Nmap XML")
		 filter.add_pattern("*." + FILE_EXT)
		 file_dialog.add_filter(filter)		 
		 filter2.set_name("Umit Bluetooth")
		 filter2.add_pattern("*." + FILE2_EXT)
		 file_dialog.add_filter(filter2)
		if (dialog_action==gtk.FILE_CHOOSER_ACTION_OPEN):
			 """Create and add the 'all files' filter"""
			 filter = gtk.FileFilter()
			 filter2 = gtk.FileFilter()
			 filter3 = gtk.FileFilter()
		     
			 if (MODE=="network"):
			     filter.set_name("Nmap XML")		     
			     filter.add_pattern("*." + FILE_EXT)		     
			     file_dialog.add_filter(filter)			 
			 elif (MODE=="bluetooth"):
			     filter2.set_name("Umit Bluetooth")
			     filter2.add_pattern("*." + FILE2_EXT)
			     file_dialog.add_filter(filter2)			
			 
			 filter3.set_name("All files")
			 filter3.add_pattern("*")
			 file_dialog.add_filter(filter3)

		"""Init the return value"""
		result = None
		if file_dialog.run() == gtk.RESPONSE_OK:
			result = file_dialog.get_filename()
			if (dialog_action==gtk.FILE_CHOOSER_ACTION_SAVE):
				 result, extension = os.path.splitext(result)
				 if(MODE=="network"):
				     result = result + "." + FILE_EXT
				 elif(MODE=="bluetooth"):
				     result = result + "." + FILE2_EXT
				 else:			         
					 print "Set Operations Mode!"
		file_dialog.destroy()
		return result
		 
	 def on_network_activate(self, widget):
		 global MODE
		 MODE = "network"
		 self.textview.get_buffer().set_text('Mode: Network')
		 context_id = self.statusbar.get_context_id("mode1")
		 self.statusbar.push(context_id, "Mode: Network")
		 self.wTree.get_widget("comboboxentry1").set_sensitive(True)
		 #set global variable so button1_clicked can knw which mode its on
		 
	 def on_bluetooth_activate(self, widget):
		 global MODE
		 MODE = "bluetooth"
		 self.textview.get_buffer().set_text('Mode: Bluetooth')
		 context_id = self.statusbar.get_context_id("mode2")
		 self.statusbar.push(context_id, "Mode: Bluetooth")
		 self.wTree.get_widget("comboboxentry1").set_sensitive(False)
		 
	 def on_about1_activate(self, widget):
		 self.about1.show()
		 
	 def on_preferences1_activate(self,widget):	     		 
		 self.pref.show()
		 page = self.notebook2.get_current_page()
		 print "Before Pref Page:"+str(page)
		 if(page==1):
		     self.notebook2.prev_page()
		 print "After Pref Page:"+str(page)
		 self.preference()
	 
	 def on_plugin1_activate(self,widget):	     
		 self.pref.show()
		 page = self.notebook2.get_current_page()
		 print "After Plugin Page:"+str(page)
		 if(page==0):
		     self.notebook2.next_page()
		 print "After Plugin Page:"+str(page)
		 self.preference()
	 
	 def about1_close(self, widget):
		 self.about1.hide_on_delete() # handler for the close button
		 self.about1.connect("delete-event",self.about1.hide_on_delete) # handler for the top right close button
	 
	 def pref_close(self, widget):
		 self.pref.hide_on_delete()
		 self.pref.connect("delete-event",self.pref.hide_on_delete)
		 
	 def button1_clicked(self, widget):
		 global MODE
		 global PROGSTATUS
		 global host
		 global flags
		 PROGSTATUS="START"
		 self.progressbar.set_text("")
		 self.progressbar.set_fraction(0)
		 self.progressbar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
		 print MODE
		 if (MODE=="network"):
			 context_id = self.statusbar.get_context_id("scan1")
			 self.statusbar.push(context_id, "Scanning...")
			 host=self.wTree.get_widget("comboboxentry1").get_active_text()
			 self.textview.get_buffer().set_text('Network scan on '+host+' ....')			 
			 command = flags + " -oX " + outf + " " + host
			 network.scanning(self, host, command)
		 elif (MODE=="bluetooth"):
			 context_id = self.statusbar.get_context_id("scan3")
			 self.statusbar.push(context_id, "Scanning...")
			 host=self.wTree.get_widget("comboboxentry1").get_active_text()
			 self.textview.get_buffer().set_text('Bluetooth scan in progress....')				 
			 bt.bt(self)
			 self.bt_list()
			 #pending work
			 #self.bt_map()
		 else:
		     self.textview.get_buffer().set_text('Mode not set yet.')
			 
     #functions more like a clear screen.Work needs to be done	for real stopping	 
	 def button2_clicked(self, widget):
		 global PROGSTATUS
		 PROGSTATUS="STOP"
		 context_id = self.statusbar.get_context_id("scan1")
		 self.statusbar.push(context_id, "")	 
		 self.textview.get_buffer().set_text('Clear. :-)')
		 self.progressbar.set_fraction(0)
		 self.progressbar.set_text("")
	 
	 def plugin_toggle( self, cell, path, model ):
		 global PLUGSELCT
		 model[path][1] = not model[path][1]
		 status =  model[path][1]		 
		 if( model[path][0] == "Neural Network Optimization(non Windows)" ):
			 #self.plugintext.get_buffer().insert_at_cursor("\nPlugin\n Status: "+str(model[path][1]))
			 if(model[path][1] == True):			     
				 print "Zaid's Plugin Activation"
				 PLUGSELCT = "zaid"
		 elif( model[path][0] == "Neural Network Optimization(Windows)\t\t\t"):
			 #self.plugintext.get_buffer().insert_at_cursor("\nPlugin\n Status: "+str(model[path][1]))
			 if(model[path][1] == True):			     
				 print "Hazwan's Plugin Activation"
				 PLUGSELCT = "hazwan"
	 
	 def preference(self):
		 global outf
		 global flags
		 buf = self.textview7.get_buffer()
		 buf2 = self.textview6.get_buffer()
		 flags = buf.get_text(*buf.get_bounds())
		 outf = buf2.get_text(*buf2.get_bounds())
		 print flags + "\n"
		 print outf
		 
	 def tree1_press(self,obj,event):
		 print "Tree 1 Click"
		 model,iter=self.treeview1.get_selection().get_selected()
		 if iter==None:
			 print "nothing was selected"
			 return
		 nodetext = model.get_value(iter,0)
		 print nodetext
	 
	 def tree2_press(self,obj,event):
		 print "Click"
		 model,iter=self.treeview2.get_selection().get_selected()
		 if iter==None:
			 print "nothing was selected"
			 return
		 nodetext = model.get_value(iter,0)
		 print "Nodetext: "+ nodetext
		 if( nodetext == "Neural Network Optimization(non Windows)" ):
			 self.plugintext.get_buffer().set_text("Neural Network Optimization(non Windows) Plugin\nVersion:TBA\nDescription:\n"			                                       
												   "Analysis of the composition of the information collected during OS\n"+ 			                                       
												   "identification process, to identify key elements and their relations.\n"+
												   "This is where the statistical field and artificial neural network will\n"+ 
												   "be implemented")
		 elif( nodetext == "Neural Network Optimization(Windows)\t\t\t"):
			 self.plugintext.get_buffer().set_text("Neural Network Optimization(Windows) Plugin\nVersion:TBA\nDescription:\n"			                                       
												   "OS fingerprinting which is focusing on the manipulation of information\n"+ 			                                       												   
												   "gained from port 135, MSRPC Endpoint Mapper. The technique will use\n"+
												   "the combination of UUID, annotation, protocol used and the endpoint\n"+ 
												   "discover from RPC endpoint mapper and later will be mapped on neural\n"+
												   "network by using perceptron network for the statistical on determine\n"+
												   "the result")
	 #BT list view
	 def bt_list(self):	     
		 count = 0
		 global btname
		 global btmac
		 global btmanu
		 self.listmodel.clear()
		 print "LEN : " + str(len(btname))
		 while (len(btname)-1) > count:
			 count+=1
			 myiter = self.listmodel.insert_after(None,None)
			 print btname[count]
			 self.listmodel.set_value(myiter,0,btname[count])
			 if(btmanu[count] == "Motorola"):
			     print "map bluetooth devices"
				 #pixbuf = gtk.gdk.pixbuf_new_from_file("ubuntu_75.png")                 
				 #self.mapmodel.append([btname[count], pixbuf])
			 string = "BT MAC: " + btmac[count] + "\nManufacturer: " + btmanu[count]			 
			 self.listmodel.set_value(myiter,1,string)
		 self.bt_map()
	 
	 #BT MAP view
	 def bt_map(self):	     
		 #self.mapview
		 self.mapview.set_model(main.mapmodel)
		 self.mapview.set_text_column(0)
		 self.mapview.set_pixbuf_column(1)
		 #clear model
		 model = gtk.ListStore(str, gtk.gdk.Pixbuf)
		 self.mapmodel = model
		 
if __name__ == "__main__": 
	 hwg = main()
	 gtk.gdk.threads_init()
	 gtk.gdk.threads_enter()
	 gtk.main()
	 gtk.gdk.threads_leave()
	 print "exit"
